<?php
defined('APP') or die('Hacking attemp!');
class Controller_Admincp extends Core_Controller{
	private $perpage = 20;
	public function __construct(){
		parent::__construct();
		parent::loadModel('admincp');
		$this->view->strfoot = $this->model->cfsite['Copyright'];
		$this->view->sitename = $this->model->cfsite['SiteName'];
		$this->view->adminemail = $this->model->cfsite['AdminEmail'];
    	}
    public function indexAction(array $param){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		$this->view->render('admin/home');
    	}
	public function signinAction(array $param){
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['amsmsignin'])){
			if(empty($_POST['email']) || trim($_POST['email'])=='')
				$this->view->err_e = 'Please enter admin email';
			elseif(empty($_POST['password']) || trim($_POST['password'])=='')
				$this->view->err_p = 'Please enter password';
			else{
				$result = $this->model->AdminLogin(trim($_POST['email']), trim($_POST['password']));
				if($result==-1)
					$this->view->error = 'An error occurred, please try again';
				elseif($result==-2)
					$this->view->error = 'Email or password incorrect !';
				else{
					$_SESSION['adminid'] = $result;
					$_SESSION['adminem'] = trim($_POST['email']);
					header('Location: '.BASE_URL.'?admincp');
					return;
					}
				}
			}
		$this->view->render('admin/signin');
    	}
	public function menuAction(){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		$this->view->logo = $this->model->cfsite['LogoName'];
		$this->view->render('admin/menu');
    	}
	public function signoutAction(){
		unset($_SESSION['adminid']);
		unset($_SESSION['adminem']);
		header('Location: '.BASE_URL.'?admincp&signin');
		return;
    	}
	public function managepagesAction(array $param){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			if($this->model->DeletePage($param['id'])){
				header('Location: '.BASE_URL.'?admincp&managepages');
				return;
				}
			else $this->view->error = 'Can not delete page';
			}
		$this->view->pages = $this->model->getAllPages();
		$this->view->render('admin/managepages');
    	}
	public function newpageAction(){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&managepages');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smnewpage'])){
			if(empty($_POST['namepage']) || trim($_POST['namepage'])=='')
				$this->view->err_n = 'Please enter the name page';
			elseif(empty($_POST['contentPage']) || trim($_POST['contentPage'])=='')
				$this->view->err_b = 'Please enter body of page';
			else{
				$isac = ($_POST['isactive']=='on')?1:0;
				$data = array('PageName' => "'".addslashes(trim($_POST['namepage']))."'", 'PageBody' => "'".addslashes(trim(htmlentities($_POST['contentPage'])))."'", 'LastUpdate' => "'".date('Y-m-d H:i:s')."'", 'IsActive' => $isac, 'OtherId' => $_POST['display']);
				$result = $this->model->AddPage($data, $_POST['display']);
				if($result==-1)
					$this->view->error = 'Can not add a page';
				elseif($result==-2)
					$this->view->error = 'Can not update other display for page and can not add page';
				else{
					header('Location: '.BASE_URL.'?admincp&managepages');
					return;
					}
				}
			}
		$this->view->pages = $this->model->getAllPages();
		$this->view->render('admin/newpage');
    	}
	public function editpageAction(array $param){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if(!array_key_exists('pid',$param) && intval($param['pid'])==0)
			die('Your bad URL');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&managepages');
			return;
			}
		$rs = $this->model->getPage($param['pid']);
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsavepage'])){
			if(empty($_POST['namepage']) || trim($_POST['namepage'])=='')
				$this->view->err_n = 'Please enter the name page';
			elseif(empty($_POST['contentPage']) || trim($_POST['contentPage'])=='')
				$this->view->err_b = 'Please enter body of page';
			else{
				$isac = ($_POST['isactive']=='on')?1:0;
				$data = array(addslashes(trim($_POST['namepage'])), addslashes(trim(htmlentities($_POST['contentPage']))), date('Y-m-d H:i:s'), $isac, $_POST['display']);
				$result = $this->model->UpdatePage($data, $rs[0]['OtherId'], $param['pid']);
				if($result==-1)
					$this->view->error = 'Can not update page';
				elseif($result==-2)
					$this->view->error = 'Can not update other display for page and can not update page';
				else{
					header('Location: '.BASE_URL.'?admincp&managepages');
					return;
					}
				}
			}
		$this->view->page = $rs;
		$this->view->other = $this->model->getOtherPages($param['pid']);
		$this->view->render('admin/editpage');
    	}
	public function managecateAction(array $param){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$data = array('Id = ' => $param['id']);
			if($this->model->__newDeleteData('cards_categories',$data)>0){
				header('Location: '.BASE_URL.'?admincp&managecate');
				return;
				}
			else $this->view->error = 'Can not delete category';
			}
		$data = array('Id','L1NameCate as Val1');
		$config['lastpage'] = $this->model->cfsite['LastPage'];
		$config['firstpage'] = $this->model->cfsite['FirstPage'];
		$config['showeachside'] = $this->model->cfsite['ShowEachSide'];
		$config['per_page'] = $this->perpage;
		$config['js_numrows_page'] = count($this->model->getDataTable('cards_categories', $data, array(),''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&managecate'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = " limit ".$config['rs_start'].", ".$config['per_page'];
		$this->view->cates = $this->model->getDataTable('cards_categories', $data, array(),$limit);
		$this->view->render('admin/managecate');
    	}
	public function newcateAction(){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&managecate');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smnewcate'])){
			if(empty($_POST['elmentname']) || trim($_POST['elmentname'])=='')
				$this->view->err_n = 'Please enter the name category';
			else{
				$data = array('L1NameCate' => "'".addslashes(trim($_POST['elmentname']))."'", 'L2NameCate' => "'".addslashes(trim($_POST['elmentname']))."'", 'DesignBy' => 0);
				$result = $this->model->__newInsertData('cards_categories', $data);
				if($result==0)
					$this->view->error = 'Can not add a category';
				else{
					header('Location: '.BASE_URL.'?admincp&managecate');
					return;
					}
				}
			}
		$this->view->render('admin/newcate');
    	}
	public function editcateAction(array $param){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if(!array_key_exists('id',$param) && intval($param['id'])==0)
			die('Your bad URL');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&managecate');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smnewcate'])){
			if(empty($_POST['elmentname']) || trim($_POST['elmentname'])=='')
				$this->view->err_n = 'Please enter the name category';
			else{
				$data = array('L1NameCate' => "'".addslashes(trim($_POST['elmentname']))."'", 'L2NameCate' => "'".addslashes(trim($_POST['elmentname']))."'", 'DesignBy' => 0);
				$where = array('Id = ' => $param['id']);
				$result = $this->model->__newUpdateData('cards_categories', $data, $where);
				if($result==0)
					$this->view->error = 'Can not update category';
				else{
					header('Location: '.BASE_URL.'?admincp&managecate');
					return;
					}
				}
			}
		$data = array('Id','L1NameCate as Val1');
		$where = array('Id = ' => $param['id']);
		$this->view->cate = $this->model->getDataTable('cards_categories', $data, $where, '');
		$this->view->render('admin/editcate');
    	}
	public function managecolorAction(array $param){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$data = array('Id = ' => $param['id']);
			if($this->model->__newDeleteData('colors',$data)>0){
				header('Location: '.BASE_URL.'?admincp&managecolor');
				return;
				}
			else $this->view->error = 'Can not delete category';
			}
		$data = array('Id','ColorName as Val1','ColorValue as Val2');
		$config['lastpage'] = $this->model->cfsite['LastPage'];
		$config['firstpage'] = $this->model->cfsite['FirstPage'];
		$config['showeachside'] = $this->model->cfsite['ShowEachSide'];
		$config['per_page'] = $this->perpage;
		$config['js_numrows_page'] = count($this->model->getDataTable('colors', $data, array(),''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&managecolor'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = " limit ".$config['rs_start'].", ".$config['per_page'];
		$this->view->colors = $this->model->getDataTable('colors', $data, array(),$limit);
		$this->view->render('admin/managecolor');
    	}
	public function newcolorAction(){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&managecolor');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smnewcolor'])){
			if(empty($_POST['elmentname']) || trim($_POST['elmentname'])=='')
				$this->view->err_n = 'Please enter the name color';
			elseif(empty($_POST['elmentval']) || trim($_POST['elmentval'])=='')
				$this->view->err_v = 'Please enter value of color';
			else{
				$data = array('ColorName' => "'".addslashes(trim($_POST['elmentname']))."'", 'ColorValue' => "'".addslashes(trim($_POST['elmentval']))."'");
				$result = $this->model->__newInsertData('colors', $data);
				if($result==0)
					$this->view->error = 'Can not add a color';
				else{
					header('Location: '.BASE_URL.'?admincp&managecolor');
					return;
					}
				}
			}
		$this->view->render('admin/newcolor');
    	}
	public function editcolorAction(array $param){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if(!array_key_exists('id',$param) && intval($param['id'])==0)
			die('Your bad URL');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&managecolor');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsave'])){
			if(empty($_POST['elmentname']) || trim($_POST['elmentname'])=='')
				$this->view->err_n = 'Please enter the name color';
			elseif(empty($_POST['elmentval']) || trim($_POST['elmentval'])=='')
				$this->view->err_v = 'Please enter value of color';
			else{
				$data = array('ColorName' => "'".addslashes(trim($_POST['elmentname']))."'", 'ColorValue' => "'".addslashes(trim($_POST['elmentval']))."'");
				$where = array('Id = ' => $param['id']);
				$result = $this->model->__newUpdateData('colors', $data, $where);
				if($result==0)
					$this->view->error = 'Can not update color';
				else{
					header('Location: '.BASE_URL.'?admincp&managecolor');
					return;
					}
				}
			}
		$data = array('Id','ColorName as Val1','ColorValue as Val2');
		$where = array('Id = ' => $param['id']);
		$this->view->color = $this->model->getDataTable('colors', $data, $where, '');
		$this->view->render('admin/editcolor');
    	}
	public function managefontAction(array $param){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$data = array('Id = ' => $param['id']);
			if($this->model->__newDeleteData('fonts',$data)>0){
				header('Location: '.BASE_URL.'?admincp&managefont');
				return;
				}
			else $this->view->error = 'Can not delete category';
			}
		$data = array('Id','FontName as Val1','FontValue as Val2');
		$config['lastpage'] = $this->model->cfsite['LastPage'];
		$config['firstpage'] = $this->model->cfsite['FirstPage'];
		$config['showeachside'] = $this->model->cfsite['ShowEachSide'];
		$config['per_page'] = $this->perpage;
		$config['js_numrows_page'] = count($this->model->getDataTable('fonts', $data, array(),''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&managefont'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = " limit ".$config['rs_start'].", ".$config['per_page'];
		$this->view->fonts = $this->model->getDataTable('fonts', $data, array(),$limit);
		$this->view->render('admin/managefont');
    	}
	public function newfontAction(){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&managefont');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smnewfont'])){
			if(empty($_POST['elmentname']) || trim($_POST['elmentname'])=='')
				$this->view->err_n = 'Please enter the name color';
			elseif(empty($_POST['elmentval']) || trim($_POST['elmentval'])=='')
				$this->view->err_v = 'Please enter value of color';
			else{
				$data = array('FontName' => "'".addslashes(trim($_POST['elmentname']))."'", 'FontValue' => "'".addslashes(trim($_POST['elmentval']))."'");
				$result = $this->model->__newInsertData('fonts', $data);
				if($result==0)
					$this->view->error = 'Can not add a font';
				else{
					header('Location: '.BASE_URL.'?admincp&managefont');
					return;
					}
				}
			}
		$this->view->render('admin/newfont');
    	}
	public function editfontAction(array $param){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if(!array_key_exists('id',$param) && intval($param['id'])==0)
			die('Your bad URL');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&managefont');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsave'])){
			if(empty($_POST['elmentname']) || trim($_POST['elmentname'])=='')
				$this->view->err_n = 'Please enter the name color';
			elseif(empty($_POST['elmentval']) || trim($_POST['elmentval'])=='')
				$this->view->err_v = 'Please enter value of color';
			else{
				$data = array('FontName' => "'".addslashes(trim($_POST['elmentname']))."'", 'FontValue' => "'".addslashes(trim($_POST['elmentval']))."'");
				$where = array('Id = ' => $param['id']);
				$result = $this->model->__newUpdateData('fonts', $data, $where);
				if($result==0)
					$this->view->error = 'Can not update font';
				else{
					header('Location: '.BASE_URL.'?admincp&managefont');
					return;
					}
				}
			}
		$data = array('Id','FontName as Val1','FontValue as Val2');
		$where = array('Id = ' => $param['id']);
		$this->view->font = $this->model->getDataTable('fonts', $data, $where, '');
		$this->view->render('admin/editfont');
    	}
	public function managegenderAction(array $param){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$data = array('Id = ' => $param['id']);
			if($this->model->__newDeleteData('genders',$data)>0){
				header('Location: '.BASE_URL.'?admincp&managegender');
				return;
				}
			else $this->view->error = 'Can not delete category';
			}
		$data = array('Id','L1Gender as Val1','L2Gender as Val2');
		$config['lastpage'] = $this->model->cfsite['LastPage'];
		$config['firstpage'] = $this->model->cfsite['FirstPage'];
		$config['showeachside'] = $this->model->cfsite['ShowEachSide'];
		$config['per_page'] = $this->perpage;
		$config['js_numrows_page'] = count($this->model->getDataTable('genders', $data, array(),''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&managegender'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = " limit ".$config['rs_start'].", ".$config['per_page'];
		$this->view->genders = $this->model->getDataTable('genders', $data, array(),$limit);
		$this->view->render('admin/managegender');
    	}
	public function newgenderAction(){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&managegender');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smnewgender'])){
			if(empty($_POST['elmentname']) || trim($_POST['elmentname'])=='')
				$this->view->err_n = 'Please enter the gender name';
			else{
				$data = array('L1Gender' => "'".addslashes(trim($_POST['elmentname']))."'", 'L2Gender' => "'".addslashes(trim($_POST['elmentname']))."'");
				$result = $this->model->__newInsertData('genders', $data);
				if($result==0)
					$this->view->error = 'Can not add a gender';
				else{
					header('Location: '.BASE_URL.'?admincp&managegender');
					return;
					}
				}
			}
		$this->view->render('admin/newgender');
    	}
	public function editgenderAction(array $param){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if(!array_key_exists('id',$param) && intval($param['id'])==0)
			die('Your bad URL');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&managegender');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsave'])){
			if(empty($_POST['elmentname']) || trim($_POST['elmentname'])=='')
				$this->view->err_n = 'Please enter the gender name';
			else{
				$data = array('L1Gender' => "'".addslashes(trim($_POST['elmentname']))."'", 'L2Gender' => "'".addslashes(trim($_POST['elmentname']))."'");
				$where = array('Id = ' => $param['id']);
				$result = $this->model->__newUpdateData('genders', $data, $where);
				if($result==0)
					$this->view->error = 'Can not update gender';
				else{
					header('Location: '.BASE_URL.'?admincp&managegender');
					return;
					}
				}
			}
		$data = array('Id','L1Gender as Val1','L2Gender as Val2');
		$where = array('Id = ' => $param['id']);
		$this->view->gender = $this->model->getDataTable('genders', $data, $where, '');
		$this->view->render('admin/editgender');
    	}
	public function managerelationshipsAction(array $param){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$data = array('Id = ' => $param['id']);
			if($this->model->__newDeleteData('relationships',$data)>0){
				header('Location: '.BASE_URL.'?admincp&managerelationships');
				return;
				}
			else $this->view->error = 'Can not delete category';
			}
		$data = array('Id','L1Status as Val1','L2Status as Val2');
		$config['lastpage'] = $this->model->cfsite['LastPage'];
		$config['firstpage'] = $this->model->cfsite['FirstPage'];
		$config['showeachside'] = $this->model->cfsite['ShowEachSide'];
		$config['per_page'] = $this->perpage;
		$config['js_numrows_page'] = count($this->model->getDataTable('relationships', $data, array(),''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&managerelationships'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = " limit ".$config['rs_start'].", ".$config['per_page'];
		$this->view->relas = $this->model->getDataTable('relationships', $data, array(),$limit);
		$this->view->render('admin/managerelationships');
    	}
	public function newrelasAction(){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&managerelationships');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smnewgender'])){
			if(empty($_POST['elmentname']) || trim($_POST['elmentname'])=='')
				$this->view->err_n = 'Please enter the relationship name';
			else{
				$data = array('L1Status' => "'".addslashes(trim($_POST['elmentname']))."'", 'L2Status' => "'".addslashes(trim($_POST['elmentname']))."'");
				$result = $this->model->__newInsertData('relationships', $data);
				if($result==0)
					$this->view->error = 'Can not add a relationship';
				else{
					header('Location: '.BASE_URL.'?admincp&managerelationships');
					return;
					}
				}
			}
		$this->view->render('admin/newrelas');
    	}
	public function editrelasAction(array $param){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if(!array_key_exists('id',$param) && intval($param['id'])==0)
			die('Your bad URL');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&managerelationships');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsave'])){
			if(empty($_POST['elmentname']) || trim($_POST['elmentname'])=='')
				$this->view->err_n = 'Please enter the gender name';
			else{
				$data = array('L1Status' => "'".addslashes(trim($_POST['elmentname']))."'", 'L2Status' => "'".addslashes(trim($_POST['elmentname']))."'");
				$where = array('Id = ' => $param['id']);
				$result = $this->model->__newUpdateData('relationships', $data, $where);
				if($result==0)
					$this->view->error = 'Can not update relationship';
				else{
					header('Location: '.BASE_URL.'?admincp&managerelationships');
					return;
					}
				}
			}
		$data = array('Id','L1Status as Val1','L2Status as Val2');
		$where = array('Id = ' => $param['id']);
		$this->view->rela = $this->model->getDataTable('relationships', $data, $where, '');
		$this->view->render('admin/editrelas');
    	}
	public function backupdbAction(){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smbackup'])){
			if( 'SQL' == $_REQUEST['output_format'] ){
				$print_form=0;
				$filname = $_REQUEST['SeltTable']."_".date('YmdHis').'.sql';
				header('Content-type: text/plain');
				header("Content-Disposition: attachment; filename=$filname");
			echo "/*mysqldump.php */\n";
			   $this->model->_mysqldump_table_data($_REQUEST['SeltTable']);
				}
			exit();
			}
		$this->view->tables = $this->model->ShowTables();
		$this->view->render('admin/backupdb');
    	}
	public function mailingAction(array $param){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smgenerate'])){
			header('Location: '.BASE_URL.'?admincp&mailing&'.http_build_query($_POST));
			return;
			}
		$arr_temp = array();
		if(array_key_exists('smgenerate',$param) && intval($param['smgenerate'])=='Generate'){
			if(trim(urldecode($param['name']))!='')
				array_push($arr_temp, "FullName like '%".trim(urldecode($param['name']))."%'");
			if(trim(urldecode($param['opbirth']))!='' && $param['opbirth']=='baf'){
				if(trim(urldecode($param['btxtyear']))!='' && intval($param['btxtyear'])>0 && checkdate(intval($param['bssmonth']), intval($param['bssday']), intval($param['btxtyear'])))
					array_push($arr_temp, "Birthday >= '".date('Y-m-d', strtotime($param['btxtyear'].'-'.$param['bssmonth'].'-'.$param['bssday']))."'");
				}
			if(trim(urldecode($param['opbirth']))!='' && $param['opbirth']=='bbf'){
				if(trim(urldecode($param['btxtyear']))!='' && intval($param['btxtyear'])>0 && checkdate(intval($param['bssmonth']), intval($param['bssday']), intval($param['btxtyear'])))
					array_push($arr_temp, "Birthday <= '".date('Y-m-d', strtotime($param['btxtyear'].'-'.$param['bssmonth'].'-'.$param['bssday']))."'");
				}
			if($param['gender']>0)
				array_push($arr_temp, "Gender = ".$param['gender']);
			if($param['relas']>0)
				array_push($arr_temp, "RelationshipId = ".$param['relas']);
			if(trim(urldecode($param['opsign']))!='' && $param['opsign']=='saf'){
				if(trim(urldecode($param['stxtyear']))!='' && intval($param['stxtyear'])>0 && checkdate(intval($param['sssmonth']), intval($param['sssday']), intval($param['stxtyear'])))
					array_push($arr_temp, "DATE_FORMAT(SignedDate,'%Y-%m-%d') >= '".date('Y-m-d', strtotime($param['stxtyear'].'-'.$param['sssmonth'].'-'.$param['sssday']))."'");
				}
			if(trim(urldecode($param['opsign']))!='' && $param['opsign']=='sbf'){
				if(trim(urldecode($param['stxtyear']))!='' && intval($param['stxtyear'])>0 && checkdate(intval($param['sssmonth']), intval($param['sssday']), intval($param['stxtyear'])))
					array_push($arr_temp, "DATE_FORMAT(SignedDate,'%Y-%m-%d') <= '".date('Y-m-d', strtotime($param['stxtyear'].'-'.$param['sssmonth'].'-'.$param['sssday']))."'");
				}
			if(trim(urldecode($param['ipaddress']))!='')
				array_push($arr_temp, "IpAddress like '%".trim(urldecode($param['ipaddress']))."%'");
			$this->view->mailings = $this->model->getMailingList($arr_temp);
			}
		$dgender = array('Id','L1Gender as Val1');
		$this->view->genders = $this->model->getDataTable('genders', $dgender, array(), '');
		$drelas = array('Id','L1Status as Val1');
		$this->view->relas = $this->model->getDataTable('relationships', $drelas, array(), '');
		$this->view->render('admin/mailing');
    	}
	public function sitesetingAction(){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsetting'])){
			if(empty($_POST['sitename']) || trim($_POST['sitename'])=='')
				$this->view->err_n = 'Please enter site name';
			elseif(empty($_POST['copyright']) || trim($_POST['copyright'])=='')
				$this->view->err_c = 'Please enter the copyright text';
			elseif(empty($_POST['firstpage']) || trim($_POST['firstpage'])=='')
				$this->view->err_f = 'Please enter label first page';
			elseif(empty($_POST['lastpage']) || trim($_POST['lastpage'])=='')
				$this->view->err_l = 'Please enter label last page';
			elseif(empty($_POST['showeach']) || trim($_POST['showeach'])=='' || intval($_POST['showeach'])==0)
				$this->view->err_s = 'Please enter page show each side';
			elseif(empty($_POST['perpage']) || trim($_POST['perpage'])=='' || intval($_POST['perpage'])==0)
				$this->view->err_p = 'Please enter records per page';
			elseif(empty($_POST['email']) || trim($_POST['email'])=='')
				$this->view->err_e = 'Please enter the copyright text';
			elseif(!$this->valid_email(trim($_POST['email'])))
				$this->view->err_e = 'Email address invalid';
			else{
				$_err = 0;
				$filename = NULL;
				if(!empty($_FILES['logo']['name'])){
					$extension = pathinfo($_FILES['logo']['name']);
					$extension = $extension['extension'];
					list($width, $height, $type, $w) = getimagesize($_FILES['logo']['tmp_name']);
					if($_FILES['logo']['size']/1024 > 50000){
						$this->view->err_g = 'Max file size is 5MB';
						$_err = 1;
						}
					elseif(!in_array(strtolower($extension), array('gif','jpg','jpeg','png'))){
						$this->view->err_g = 'File format is \'gif, jpg, jpeg, png\'';
						$_err = 1;
						}
					elseif($width>484 || $height>75){
						$this->view->err_g = 'Recommended max-width:484px and max-height:75px';
						$_err = 1;
						}
					else{
						$temp = $this->random_string(16);
						$filename = $temp.'.'.$extension;
						if(!move_uploaded_file($_FILES['logo']['tmp_name'],dirname(dirname(__FILE__)).'/public/fuploads/'.$filename)){
							$this->view->err_g = 'An error while upload file';
							$_err = 1;
							}				
						}
					}
				if($_err==0){
					$data = array(addslashes(trim($_POST['sitename'])), $_POST['require'], addslashes(htmlentities(trim($_POST['copyright']))), $filename, addslashes(trim($_POST['firstpage'])), addslashes(trim($_POST['lastpage'])), intval($_POST['showeach']), intval($_POST['perpage']), addslashes(trim($_POST['email'])));
					if(!$this->model->updSettingSite($data))
						$this->view->error = 'An error occurred, please try again';
					else $this->view->succ = 'Your settings saved successfull';
					}
				}
			}
		$dset = array('Id','RequiredToLoginToSend','Copyright','LogoName','LastPage','FirstPage','ShowEachSide','RecordsPerPage','AdminEmail','SiteName');
		$this->view->seting = $this->model->getDataTable('site_settings', $dset, array(), '');
		$this->view->render('admin/siteseting');
    	}
	public function changepassAction(){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smchange'])){
			if(empty($_POST['curpass']) || trim($_POST['curpass'])=='')
				$this->view->err_c = 'Please enter current password';
			elseif(empty($_POST['newpass']) || trim($_POST['newpass'])=='')
				$this->view->err_n = 'Please enter new password';
			elseif(trim($_POST['newpass'])!=trim($_POST['repass']))
				$this->view->err_r = 'Please verify new password';
			else{
				$data = array($_SESSION['adminid'], trim($_POST['curpass']), trim($_POST['newpass']), $this->random_string(6));
				$resul = $this->model->adminChangePass($data);
				if($resul==-1)
					$this->view->error = 'An error occurred, please try again';
				elseif($resul==-2)
					$this->view->err_c = 'Current password incorrect !';
				elseif($resul==-3)
					$this->view->error = 'Can not change your password';
				else $this->view->succ = 'Your password changed successfull';
				}
			}
		$this->view->render('admin/changepass');
    	}
	public function cleanupAction(){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcleanup'])){
			$curdate = strtotime ( '- 1 days' , strtotime (date('Y-m-d')) ) ;
			$data = array('IsActive = ' => 0, " and DATE_FORMAT(SignedDate,'%Y-%m-%d') <= " => "'".date('Y-m-d',$curdate)."'");
			if($this->model->__newDeleteData('users',$data)>0){
				$newdt = array("DATE_FORMAT(LiftBanDate,'%Y-%m-%d') <= " => "'".date('Y-m-d')."'", ' and LiftBanDate is not null ' => '');
				if($this->model->__newDeleteData('banedusers',$newdt)>0)
					$this->view->succ = 'Cleaned up successfull !!';
				else $this->view->error = 'Can not unban user lift banned';
				}
			else $this->view->error = 'An error occurred, please try again';
			}
		$this->view->render('admin/cleanup');
    	}
	public function manageusersAction(array $param){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smseach'])){
			header('Location: '.BASE_URL.'?admincp&manageusers&'.http_build_query($_POST));
			return;
			}
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$data = array('Id = ' => $param['id']);
			$rsl = $this->model->removeUser($param['id']);
			if($rsl > 0){
				header('Location: '.BASE_URL.'?admincp&manageusers');
				return;
				}
			elseif($rsl==-1) $this->view->error = 'An error occurred, please try again';
			elseif($rsl==-2) $this->view->error = 'Can not remove ecards from user';
			elseif($rsl==-3) $this->view->error = 'Can not delete user';
			elseif($rsl==-4) $this->view->error = 'User is not exits';
			}
		$arr_temp = array();
		if(array_key_exists('smseach',$param) && intval($param['smseach'])=='SEARCH'){
			if(trim(urldecode($param['name']))!='')
				array_push($arr_temp, "CONCAT(FullName,' ',Email) like '%".trim(urldecode($param['name']))."%'");
			if(trim(urldecode($param['opbirth']))!='' && $param['opbirth']=='baf'){
				if(trim(urldecode($param['btxtyear']))!='' && intval($param['btxtyear'])>0 && checkdate(intval($param['bssmonth']), intval($param['bssday']), intval($param['btxtyear'])))
					array_push($arr_temp, "Birthday >= '".date('Y-m-d', strtotime($param['btxtyear'].'-'.$param['bssmonth'].'-'.$param['bssday']))."'");
				}
			if(trim(urldecode($param['opbirth']))!='' && $param['opbirth']=='bbf'){
				if(trim(urldecode($param['btxtyear']))!='' && intval($param['btxtyear'])>0 && checkdate(intval($param['bssmonth']), intval($param['bssday']), intval($param['btxtyear'])))
					array_push($arr_temp, "Birthday <= '".date('Y-m-d', strtotime($param['btxtyear'].'-'.$param['bssmonth'].'-'.$param['bssday']))."'");
				}
			if($param['gender']>0)
				array_push($arr_temp, "Gender = ".$param['gender']);
			if($param['relas']>0)
				array_push($arr_temp, "RelationshipId = ".$param['relas']);
			if(trim(urldecode($param['opsign']))!='' && $param['opsign']=='saf'){
				if(trim(urldecode($param['stxtyear']))!='' && intval($param['stxtyear'])>0 && checkdate(intval($param['sssmonth']), intval($param['sssday']), intval($param['stxtyear'])))
					array_push($arr_temp, "DATE_FORMAT(SignedDate,'%Y-%m-%d') >= '".date('Y-m-d', strtotime($param['stxtyear'].'-'.$param['sssmonth'].'-'.$param['sssday']))."'");
				}
			if(trim(urldecode($param['opsign']))!='' && $param['opsign']=='sbf'){
				if(trim(urldecode($param['stxtyear']))!='' && intval($param['stxtyear'])>0 && checkdate(intval($param['sssmonth']), intval($param['sssday']), intval($param['stxtyear'])))
					array_push($arr_temp, "DATE_FORMAT(SignedDate,'%Y-%m-%d') <= '".date('Y-m-d', strtotime($param['stxtyear'].'-'.$param['sssmonth'].'-'.$param['sssday']))."'");
				}
			if(trim(urldecode($param['ipaddress']))!='')
				array_push($arr_temp, "IpAddress like '%".trim(urldecode($param['ipaddress']))."%'");
			}
		$config['lastpage'] = $this->model->cfsite['LastPage'];
		$config['firstpage'] = $this->model->cfsite['FirstPage'];
		$config['showeachside'] = $this->model->cfsite['ShowEachSide'];
		$config['per_page'] = $this->perpage;
		$config['js_numrows_page'] = count($this->model->getAllUsers(array('GroupId = ' => 1),'', $arr_temp));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&manageusers'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = " limit ".$config['rs_start'].", ".$config['per_page'];
		$this->view->users = $this->model->getAllUsers(array('GroupId = ' => 1),$limit, $arr_temp);
		$dgender = array('Id','L1Gender as Val1');
		$this->view->genders = $this->model->getDataTable('genders', $dgender, array(), '');
		$drelas = array('Id','L1Status as Val1');
		$this->view->relas = $this->model->getDataTable('relationships', $drelas, array(), '');
		$dbaned = array('Id','UserId as Val1');
		$this->view->banned = $this->model->getDataTable('banedusers', $dbaned, array(), '');
		$this->view->render('admin/manageusers');
    	}
	public function banuserAction(array $param){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if(!array_key_exists('id',$param) && intval($param['id'])==0)
			die('Your bad URL');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smban'])){
			if(empty($_POST['Reason']) || trim($_POST['Reason'])=='')
				$this->view->err_r = 'Please enter reason to show the user';
			else{
				$curdate = date('Y-m-d H:i:s');
				$ip = ($_POST['banip']=='on')?"'".$_POST['hddip']."'":'NULL';
				if($_POST['liftban']==-1)
					$data = array('UserId' => $param['id'], 'BannedDate' => "'".$curdate."'", 'LiftBanDate' => 'NULL', 'Reason' => "'".addslashes(trim($_POST['Reason']))."'", 'BanIP' => $ip);
				else{
					$liftdate = strtotime ( '+ '.$_POST['liftban'].' days' , strtotime ($curdate) ) ;
					$data = array('UserId' => $param['id'], 'BannedDate' => "'".$curdate."'", 'LiftBanDate' => "'".date('Y-m-d H:i:s', $liftdate)."'", 'Reason' => "'".addslashes(trim($_POST['Reason']))."'", 'BanIP' => $ip);
				}
				$result = $this->model->__newInsertData('banedusers', $data);
				if($result==0)
					$this->view->error = 'Can not ban an user';
				else{
					header('Location: '.BASE_URL.'?admincp&manageusers');
					return;
					}
				}
			}
		$duser = array('Id','Email','IpAddress');
		$this->view->user = $this->model->getDataTable('users', $duser, array('Id = ' => $param['id']), '');
		$this->view->render('admin/banuser');
    	}
	public function newuserAction(){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&manageusers');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smaduser'])){
			if(empty($_POST['email']) || trim($_POST['email'])=='')
				$this->view->err_e = 'Please enter email address';
			elseif(!$this->valid_email(trim($_POST['email'])))
				$this->view->err_e = 'This email invalid';
			elseif($this->model->UserExits(trim($_POST['email'])))
				$this->view->err_e = 'This email already in used';
			elseif(empty($_POST['password']) || trim($_POST['password'])=='')
				$this->view->err_p = 'Please enter password';
			elseif(trim($_POST['password']) != trim($_POST['repassword']))
				$this->view->err_v = 'Please verify password';
			elseif(!empty($_POST['btxtyear']) && intval($_POST['btxtyear'])>date('Y'))
				$this->view->err_d = 'Year of birthday must be less than current year';
			elseif(($_POST['bssmonth']>0 || $_POST['bssday']>0 || !empty($_POST['btxtyear'])) && !checkdate(intval($_POST['bssmonth']), intval($_POST['bssday']), intval($_POST['btxtyear'])))
				$this->view->err_d = 'Birth day invalid';
			else{
				$_err = 0;
				$filename = NULL;
				if(!empty($_FILES['photo']['name'])){
					$extension = pathinfo($_FILES['photo']['name']);
					$extension = $extension['extension'];
					list($width, $height, $type, $w) = getimagesize($_FILES['photo']['tmp_name']);
					if($_FILES['photo']['size']/1024 > 50000){
						$this->view->err_f = 'Max file size is 5MB';
						$_err = 1;
						}
					elseif(!in_array(strtolower($extension), array('gif','jpg','jpeg','png'))){
						$this->view->err_f = 'File format is \'gif, jpg, jpeg, png\'';
						$_err = 1;
						}
					elseif($width>115 || $height>115){
						$this->view->err_f = 'Width and Height max is 115 pixels';
						$_err = 1;
						}
					else{
						$temp = $this->random_string(16);
						$filename = $temp.'.'.$extension;
						if(!move_uploaded_file($_FILES['photo']['tmp_name'],dirname(dirname(__FILE__)).'/public/fuploads/'.$filename)){
							$this->view->err_f = 'An error while upload file';
							$_err = 1;
							}				
						}
					}
				if(intval($_err)==0){
					$str = $this->random_string(6);
					$strrandom = sha1($this->random_string(32).trim($_POST['email']).$str);
					$data = array('Email' => "'".addslashes(trim($_POST['email']))."'", 'FullName' => "'".addslashes(trim($_POST['fullname']))."'", 'Birthday' => "'".trim($_POST['btxtyear']).'-'.$_POST['bssmonth'].'/'.$_POST['bssday']."'", 'Password' => "'".md5($str.addslashes(trim($_POST['password'])))."'", 'RandomStr' => "'".$str."'", 'StrActive' => "'".$strrandom."'", 'IsActive' => 1, 'SignedDate' => "'".date('Y-m-d H:i:s')."'", 'LastLogin' => "'".date('Y-m-d H:i:s')."'", 'IpAddress' => "'".$this->IpAddress()."'", 'GroupId' => 1, 'Photo' => "'".$filename."'", 'Gender' => $_POST['gender'], 'MobileNumber' => "'".addslashes(trim($_POST['mobile']))."'", 'RelationshipId' => $_POST['relationship'], 'Location' => "'".addslashes(trim($_POST['location']))."'", 'Religion' => "'".addslashes(trim($_POST['religion']))."'");
					if($this->model->__newInsertData('users', $data)>0){
						header('Location: '.BASE_URL.'?admincp&manageusers');
						return;
						}
					else $this->view->error = 'An error occurred, please try again';
					}
				}
			}
		$dgender = array('Id','L1Gender as Val1');
		$this->view->genders = $this->model->getDataTable('genders', $dgender, array(), '');
		$drelas = array('Id','L1Status as Val1');
		$this->view->relas = $this->model->getDataTable('relationships', $drelas, array(), '');
		$this->view->render('admin/newuser');
    	}
	public function edituserAction(array $param){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if(!array_key_exists('id',$param) && intval($param['id'])==0)
			die('Your bad URL');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&manageusers');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsaveuser'])){
			if(empty($_POST['email']) || trim($_POST['email'])=='')
				$this->view->err_e = 'Please enter email address';
			elseif(!$this->valid_email(trim($_POST['email'])))
				$this->view->err_e = 'This email invalid';
			elseif(strtolower(trim($_POST['email'])) != strtolower(trim($_POST['hddmail'])) && $this->model->UserExits(trim($_POST['email'])))
				$this->view->err_e = 'This email already in used';
			elseif(!empty($_POST['btxtyear']) && intval($_POST['btxtyear'])>date('Y'))
				$this->view->err_d = 'Year of birthday must be less than current year';
			elseif(($_POST['bssmonth']>0 || $_POST['bssday']>0 || !empty($_POST['btxtyear'])) && !checkdate(intval($_POST['bssmonth']), intval($_POST['bssday']), intval($_POST['btxtyear'])))
				$this->view->err_d = 'Birth day invalid';
			else{
				$_err = 0;
				$filename = NULL;
				if(!empty($_FILES['photo']['name'])){
					$extension = pathinfo($_FILES['photo']['name']);
					$extension = $extension['extension'];
					list($width, $height, $type, $w) = getimagesize($_FILES['photo']['tmp_name']);
					if($_FILES['photo']['size']/1024 > 50000){
						$this->view->err_f = 'Max file size is 5MB';
						$_err = 1;
						}
					elseif(!in_array(strtolower($extension), array('gif','jpg','jpeg','png'))){
						$this->view->err_f = 'File format is \'gif, jpg, jpeg, png\'';
						$_err = 1;
						}
					elseif($width>115 || $height>115){
						$this->view->err_f = 'Width and Height max is 115 pixels';
						$_err = 1;
						}
					else{
						$temp = $this->random_string(16);
						$filename = $temp.'.'.$extension;
						if(!move_uploaded_file($_FILES['photo']['tmp_name'],dirname(dirname(__FILE__)).'/public/fuploads/'.$filename)){
							$this->view->err_f = 'An error while upload file';
							$_err = 1;
							}				
						}
					}
				if(intval($_err)==0){
					if(strtolower(trim($_POST['email'])) != strtolower(trim($_POST['hddmail']))){
						if(!empty($filename) && !is_null($filename))
							$data = array('Email' => "'".addslashes(trim($_POST['email']))."'", 'FullName' => "'".addslashes(trim($_POST['fullname']))."'", 'Birthday' => "'".trim($_POST['btxtyear']).'-'.$_POST['bssmonth'].'/'.$_POST['bssday']."'", 'Photo' => "'".$filename."'", 'Gender' => $_POST['gender'], 'MobileNumber' => "'".addslashes(trim($_POST['mobile']))."'", 'RelationshipId' => $_POST['relationship'], 'Location' => "'".addslashes(trim($_POST['location']))."'", 'Religion' => "'".addslashes(trim($_POST['religion']))."'");
						else $data = array('Email' => "'".addslashes(trim($_POST['email']))."'", 'FullName' => "'".addslashes(trim($_POST['fullname']))."'", 'Birthday' => "'".trim($_POST['btxtyear']).'-'.$_POST['bssmonth'].'/'.$_POST['bssday']."'", 'Gender' => $_POST['gender'], 'MobileNumber' => "'".addslashes(trim($_POST['mobile']))."'", 'RelationshipId' => $_POST['relationship'], 'Location' => "'".addslashes(trim($_POST['location']))."'", 'Religion' => "'".addslashes(trim($_POST['religion']))."'");
						}
					else{
						if(!empty($filename) && !is_null($filename))
							$data = array('FullName' => "'".addslashes(trim($_POST['fullname']))."'", 'Birthday' => "'".trim($_POST['btxtyear']).'-'.$_POST['bssmonth'].'/'.$_POST['bssday']."'", 'Photo' => "'".$filename."'", 'Gender' => $_POST['gender'], 'MobileNumber' => "'".addslashes(trim($_POST['mobile']))."'", 'RelationshipId' => $_POST['relationship'], 'Location' => "'".addslashes(trim($_POST['location']))."'", 'Religion' => "'".addslashes(trim($_POST['religion']))."'");
						else $data = array('FullName' => "'".addslashes(trim($_POST['fullname']))."'", 'Birthday' => "'".trim($_POST['btxtyear']).'-'.$_POST['bssmonth'].'/'.$_POST['bssday']."'", 'Gender' => $_POST['gender'], 'MobileNumber' => "'".addslashes(trim($_POST['mobile']))."'", 'RelationshipId' => $_POST['relationship'], 'Location' => "'".addslashes(trim($_POST['location']))."'", 'Religion' => "'".addslashes(trim($_POST['religion']))."'");
						}
					$where = array('Id = ' => $param['id']);
					if($this->model->__newUpdateData('users', $data, $where)>0){
						header('Location: '.BASE_URL.'?admincp&manageusers');
						return;
						}
					else $this->view->error = 'An error occurred, please try again';
					}
				}
			}
		$duser = array('Id','Email','FullName','Birthday','Photo','Gender','MobileNumber','RelationshipId','Location','Religion');
		$this->view->user = $this->model->getDataTable('users', $duser, array('Id = ' => $param['id']), '');
		$dgender = array('Id','L1Gender as Val1');
		$this->view->genders = $this->model->getDataTable('genders', $dgender, array(), '');
		$drelas = array('Id','L1Status as Val1');
		$this->view->relas = $this->model->getDataTable('relationships', $drelas, array(), '');
		$this->view->render('admin/edituser');
    	}
	public function managecardsAction(array $param){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smseach'])){
			header('Location: '.BASE_URL.'?admincp&managecards&'.http_build_query($_POST));
			return;
			}
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$rsl = $this->model->delEcard($param['id']);
			if($rsl > 0){
				header('Location: '.BASE_URL.'?admincp&managecards');
				return;
				}
			elseif($rsl==-1) $this->view->error = 'An error occurred, please try again';
			elseif($rsl==-2) $this->view->error = 'Can not remove ecards';
			}
		$arr_temp = array();
		if(array_key_exists('smseach',$param) && intval($param['smseach'])=='SEARCH'){
			if(trim(urldecode($param['name']))!='')
				array_push($arr_temp, "CardName like '%".trim(urldecode($param['name']))."%'");
			if($param['cate']>0)
				array_push($arr_temp, "CardCate = ".$param['cate']);
			}
		$config['lastpage'] = $this->model->cfsite['LastPage'];
		$config['firstpage'] = $this->model->cfsite['FirstPage'];
		$config['showeachside'] = $this->model->cfsite['ShowEachSide'];
		$config['per_page'] = $this->perpage;
		$config['js_numrows_page'] = count($this->model->getAlleCards('', $arr_temp));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&managecards'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = " limit ".$config['rs_start'].", ".$config['per_page'];
		$this->view->users = $this->model->getAlleCards($limit, $arr_temp);
		$drelas = array('Id','L1NameCate as Val1');
		$this->view->cate = $this->model->getDataTable('cards_categories', $drelas, array(), '');
		$this->view->render('admin/managecards');
    	}
	public function newcardAction(){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&managecards');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadcard'])){
			if(empty($_POST['name']) || trim($_POST['name'])=='')
				$this->view->err_e = 'Please enter name card';
			elseif(empty($_FILES['photo']['name']))
				$this->view->err_f = 'Please select image for card';
			else{
				$_err = 0;
				$filename = NULL;
				$extension = pathinfo($_FILES['photo']['name']);
				$extension = $extension['extension'];
				list($width, $height, $type, $w) = getimagesize($_FILES['photo']['tmp_name']);
				if($_FILES['photo']['size']/1024 > 50000){
					$this->view->err_f = 'Max file size is 5MB';
					$_err = 1;
					}
				elseif(!in_array(strtolower($extension), array('gif','jpg','jpeg','png'))){
					$this->view->err_f = 'File format is \'gif, jpg, jpeg, png\'';
					$_err = 1;
					}
				elseif($width>210 || $height>280){
					$this->view->err_f = 'Please recommended max-width:210px and max-height:280px';
					$_err = 1;
					}
				else{
					$temp = $this->random_string(16);
					$filename = $temp.'.'.$extension;
					if(!move_uploaded_file($_FILES['photo']['tmp_name'],dirname(dirname(__FILE__)).'/public/ecards/'.$filename)){
						$this->view->err_f = 'An error while upload file';
						$_err = 1;
						}				
					}
				if(intval($_err)==0 && !is_null($filename)){
					$data = array('CardCate' => $_POST['cate'],'CardName' => "'".addslashes(trim($_POST['name']))."'", 'CardImg' => "'".$filename."'", 'ShortDesc' => "'".addslashes(trim($_POST['shordesc']))."'", 'IsText' => 0,'TopMessage' => 0, 'LeftMessage' => 0, 'LikeNumber' => 0, 'TotalPoints' => 0, 'TotalRated' => 0, 'TotalSent' => 0, 'TotalViews' => 0, 'DateCreated' => "'".date('Y-m-d H:i:s')."'");
					if($this->model->__newInsertData('greetingcards', $data)>0){
						header('Location: '.BASE_URL.'?admincp&managecards');
						return;
						}
					else $this->view->error = 'An error occurred, please try again';
					}
				}
			}
		$drelas = array('Id','L1NameCate as Val1');
		$this->view->cate = $this->model->getDataTable('cards_categories', $drelas, array(), '');
		$this->view->render('admin/newcard');
    	}
	public function editcardAction(array $param){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?admincp&managecards');
			return;
			}
		if(!array_key_exists('id',$param) && intval($param['id'])==0)
			die('Your bad URL');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smadcard'])){
			if(empty($_POST['name']) || trim($_POST['name'])=='')
				$this->view->err_e = 'Please enter name card';
			else{
				$_err = 0;
				$filename = NULL;
				if(!empty($_FILES['photo']['name'])){
					$extension = pathinfo($_FILES['photo']['name']);
					$extension = $extension['extension'];
					list($width, $height, $type, $w) = getimagesize($_FILES['photo']['tmp_name']);
					if($_FILES['photo']['size']/1024 > 50000){
						$this->view->err_f = 'Max file size is 5MB';
						$_err = 1;
						}
					elseif(!in_array(strtolower($extension), array('gif','jpg','jpeg','png'))){
						$this->view->err_f = 'File format is \'gif, jpg, jpeg, png\'';
						$_err = 1;
						}
					elseif($width>210 || $height>280){
						$this->view->err_f = 'Please recommended max-width:210px and max-height:280px';
						$_err = 1;
						}
					else{
						$temp = $this->random_string(16);
						$filename = $temp.'.'.$extension;
						if(!move_uploaded_file($_FILES['photo']['tmp_name'],dirname(dirname(__FILE__)).'/public/ecards/'.$filename)){
							$this->view->err_f = 'An error while upload file';
							$_err = 1;
							}				
						}
					}
				if(intval($_err)==0){
					if(!empty($filename) && !is_null($filename))
						$data = array('CardCate' => $_POST['cate'],'CardName' => "'".addslashes(trim($_POST['name']))."'", 'CardImg' => "'".$filename."'", 'ShortDesc' => "'".addslashes(trim($_POST['shordesc']))."'");
					else $data = array('CardCate' => $_POST['cate'],'CardName' => "'".addslashes(trim($_POST['name']))."'", 'ShortDesc' => "'".addslashes(trim($_POST['shordesc']))."'");
					$where = array('Id = '=>$param['id']);
					if($this->model->__newUpdateData('greetingcards', $data, $where)>0){
						header('Location: '.BASE_URL.'?admincp&managecards');
						return;
						}
					else $this->view->error = 'An error occurred, please try again';
					}
				}
			}
		$dcard = array('CardCate','CardName','CardImg','ShortDesc');
		$this->view->card = $this->model->getDataTable('greetingcards', $dcard, array('Id = '=>$param['id']), '');
		$drelas = array('Id','L1NameCate as Val1');
		$this->view->cate = $this->model->getDataTable('cards_categories', $drelas, array(), '');
		$this->view->render('admin/editcard');
    	}
	public function listbannedAction(array $param){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smseach'])){
			header('Location: '.BASE_URL.'?admincp&listbanned&'.http_build_query($_POST));
			return;
			}
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && trim($param['a'])=='d'){
			$data = array('Id = ' => $param['id']);
			if($this->model->__newDeleteData('banedusers',$data)>0){
				header('Location: '.BASE_URL.'?admincp&listbanned');
				return;
				}
			else $this->view->error = 'An error occurred, please try again';
			}
		$arr_temp = array();
		if(array_key_exists('smseach',$param) && intval($param['smseach'])=='SEARCH'){
			if(trim(urldecode($param['name']))!='')
				array_push($arr_temp, "Email like '%".trim(urldecode($param['name']))."%'");
			if(trim(urldecode($param['opbirth']))!='' && $param['opbirth']=='baf'){
				if(trim(urldecode($param['btxtyear']))!='' && intval($param['btxtyear'])>0 && checkdate(intval($param['bssmonth']), intval($param['bssday']), intval($param['btxtyear'])))
					array_push($arr_temp, "DATE_FORMAT(BannedDate,'%Y-%m-%d') >= '".date('Y-m-d', strtotime($param['btxtyear'].'-'.$param['bssmonth'].'-'.$param['bssday']))."'");
				}
			if(trim(urldecode($param['opbirth']))!='' && $param['opbirth']=='bbf'){
				if(trim(urldecode($param['btxtyear']))!='' && intval($param['btxtyear'])>0 && checkdate(intval($param['bssmonth']), intval($param['bssday']), intval($param['btxtyear'])))
					array_push($arr_temp, "DATE_FORMAT(BannedDate,'%Y-%m-%d') < '".date('Y-m-d', strtotime($param['btxtyear'].'-'.$param['bssmonth'].'-'.$param['bssday']))."'");
				}
			}
		$config['lastpage'] = $this->model->cfsite['LastPage'];
		$config['firstpage'] = $this->model->cfsite['FirstPage'];
		$config['showeachside'] = $this->model->cfsite['ShowEachSide'];
		$config['per_page'] = $this->perpage;
		$config['js_numrows_page'] = count($this->model->getListBanned('', $arr_temp));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?admincp&listbanned'.$strquery;
		$this->view->ttpage = $this->Pagination($config);
		$limit = " limit ".$config['rs_start'].", ".$config['per_page'];
		$this->view->lists = $this->model->getListBanned($limit, $arr_temp);
		$this->view->render('admin/listbanned');
    	}
	public function editbanAction(array $param){
		if(!isset($_SESSION['adminid'])){
			header('Location: '.BASE_URL.'?admincp&signin');
			return;
			}
		if(!array_key_exists('id',$param) && intval($param['id'])==0)
			die('Your bad URL');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smupdban'])){
			if(empty($_POST['Reason']) || trim($_POST['Reason'])=='')
				$this->view->err_r = 'Please enter reason to show the user';
			else{
				$curdate = date('Y-m-d H:i:s');
				$ip = ($_POST['banip']=='on')?"'".$_POST['hddip']."'":'NULL';
				if($_POST['liftban']==-1)
					$data = array('LiftBanDate' => 'NULL', 'Reason' => "'".addslashes(trim($_POST['Reason']))."'", 'BanIP' => $ip);
				else{
					$liftdate = strtotime ( '+ '.$_POST['liftban'].' days' , strtotime ($curdate) ) ;
					$data = array('LiftBanDate' => "'".date('Y-m-d H:i:s', $liftdate)."'", 'Reason' => "'".addslashes(trim($_POST['Reason']))."'", 'BanIP' => $ip);
				}
				if($this->model->__newUpdateData('banedusers', $data, array('Id = ' => $param['id']))>0){
					header('Location: '.BASE_URL.'?admincp&listbanned');
					return;
					}
				else $this->view->error = 'Can not edit ban user';
				}
			}
		$this->view->ban = $this->model->getBanDetail($param['id']);
		$this->view->render('admin/editban');
    	}
	public function admforgotAction(){
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['amsmsignin'])){
			if(empty($_POST['email']) || trim($_POST['email'])=='')
				$this->view->err_e = 'Please enter admin email';
			elseif(!$this->valid_email(trim($_POST['email'])))
				$this->view->err_e = 'Your email invalid';
			elseif(empty($_POST['code']) || trim($_POST['code'])=='')
				$this->view->err_c = 'Please enter security code';
			elseif(trim($_POST['code']) != $_SESSION['encoded_captcha'])
				$this->view->err_c = 'Security code incorrect';
			else{
				$result = $this->model->AdminForgotPass(trim($_POST['email']), trim($_POST['code']), $this->random_string(32));
				if($result==-1)
					$this->view->error = 'An error occurred, please try again';
				elseif($result==-2)
					$this->view->error = 'Email not exits !';
				elseif($result==-3)
					$this->view->error = 'Can not process request';
				else{
					$mess = 'Dear, '.$_POST['email'].' !!<br><br>Please <a href="'.BASE_URL.'?admincp&recoverpass&str='.$result.'">click here</a> to reset your password on '.$this->model->cfsite['SiteName'].'<br><br>
Best regards !';
					$this->view->succ = 'An email has sent to you. Please check email for recovery password';
					@mail(trim($_POST['email']), '=?UTF-8?B?'.base64_encode('Active account '.$this->model->cfsite['SiteName']).'?=', $mess, "Content-Type: text/html; charset=utf-8\r\nFrom: ".$this->model->cfsite['AdminEmail']);
					}
				}
			}
		$this->view->render('admin/admforgot');
    	}
	public function recoverpassAction(array $param){
		if(!array_key_exists('str',$param) && empty($param['str']) || trim($param['str'])=='')
			die('Your bad URL');
		if(!$this->model->chkInput($param['str']))
			$this->view->invalid = 'Your input data invalid';
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['amsmreco'])){
			if(empty($_POST['newpass']) || trim($_POST['newpass'])=='')
				$this->view->err_n = 'Please enter new password';
			elseif(trim($_POST['newpass'])!=trim($_POST['repass']))
				$this->view->err_r = 'Please verify new password';
			elseif(empty($_POST['code']) || trim($_POST['code'])=='')
				$this->view->err_c = 'Please enter security code';
			elseif(trim($_POST['code']) != $_SESSION['encoded_captcha'])
				$this->view->err_c = 'Security code incorrect';
			else{
				if(!$this->model->AdminResetPass(trim($_POST['newpass']), trim($_POST['code']), $this->random_string(32), $param['str']))
					$this->view->error = 'An error occurred, please try again';
				else $this->view->succ = 'Your password changed successfull. <a href="?admincp&signin"><i>Sign-in here</i></a>';
				}
			}
		$this->view->render('admin/recoverpass');
    	}
	}